// 01-03-2018
//   adaptation pour Touch screen ILI9341
// 19-01-2018
// pour ILI9225  170x220 
// rajout  usage du gestionnaire de Memoire
 // font en const unsigned char .. car sinon trop de RAM utilise
 // 10-01/2018


#define Byte unsigned char
#define Word unsigned int

#define _RST LATC0_bit
#define _RS  LATC1_bit    //Command (RS=0)  Parameter (RS=1)
#define _CS  LATC2_bit    // Chip Select
#define _SDI LATC5_Bit   // MOSI
#define _CLK LATC3_Bit   // SCK


#define Max_Lcd_Buff 320L*240L
#define ILI9341_TFTWIDTH  240
#define ILI9341_TFTHEIGHT 320


#define ILI9341_NOP     0x00
#define ILI9341_SWRESET 0x01
#define ILI9341_RDDID   0x04
#define ILI9341_RDDST   0x09

#define ILI9341_SLPIN   0x10
#define ILI9341_SLPOUT  0x11
#define ILI9341_PTLON   0x12
#define ILI9341_NORON   0x13

#define ILI9341_RDMODE  0x0A
#define ILI9341_RDMADCTL  0x0B
#define ILI9341_RDPIXFMT  0x0C
#define ILI9341_RDIMGFMT  0x0D
#define ILI9341_RDSELFDIAG  0x0F

#define ILI9341_INVOFF  0x20
#define ILI9341_INVON   0x21
#define ILI9341_GAMMASET 0x26
#define ILI9341_DISPOFF 0x28
#define ILI9341_DISPON  0x29

#define ILI9341_CASET   0x2A
#define ILI9341_PASET   0x2B
#define ILI9341_RAMWR   0x2C
#define ILI9341_RAMRD   0x2E

#define ILI9341_PTLAR    0x30
#define ILI9341_MADCTL   0x36

// bits choix orientations
#define MADCTL_ML  0x10
#define MADCTL_MV  0x20
#define MADCTL_MX  0x40
#define MADCTL_MY  0x80
#define MADCTL_RGB 0x00
#define MADCTL_MH  0x04
#define MADCTL_BGR 0x08

#define ILI9341_VSCRSADD 0x37
#define ILI9341_PIXFMT   0x3A

#define ILI9341_FRMCTR1 0xB1
#define ILI9341_FRMCTR2 0xB2
#define ILI9341_FRMCTR3 0xB3
#define ILI9341_INVCTR  0xB4
#define ILI9341_DFUNCTR 0xB6

#define ILI9341_PWCTR1  0xC0
#define ILI9341_PWCTR2  0xC1
#define ILI9341_PWCTR3  0xC2
#define ILI9341_PWCTR4  0xC3
#define ILI9341_PWCTR5  0xC4
#define ILI9341_VMCTR1  0xC5
#define ILI9341_VMCTR2  0xC7

#define ILI9341_RDID1   0xDA
#define ILI9341_RDID2   0xDB
#define ILI9341_RDID3   0xDC
#define ILI9341_RDID4   0xDD

#define ILI9341_GMCTRP1 0xE0
#define ILI9341_GMCTRN1 0xE1

#define ILI9341_INVOFF  0x20
#define ILI9341_INVON   0x21

/* RGB 16-bit color table definition (RG565) */
#define COLOR_BLACK          0x0000      /*   0,   0,   0 */
#define COLOR_WHITE          0xFFFF      /* 255, 255, 255 */
#define COLOR_BLUE           0x001F      /*   0,   0, 255 */
#define COLOR_GREEN          0x07E0      /*   0, 255,   0 */
#define COLOR_RED            0xF800      /* 255,   0,   0 */
#define COLOR_NAVY           0x000F      /*   0,   0, 128 */
#define COLOR_DARKBLUE       0x0011      /*   0,   0, 139 */
#define COLOR_DARKGREEN      0x03E0      /*   0, 128,   0 */
#define COLOR_DARKCYAN       0x03EF      /*   0, 128, 128 */
#define COLOR_CYAN           0x07FF      /*   0, 255, 255 */
#define COLOR_TURQUOISE      0x471A      /*  64, 224, 208 */
#define COLOR_INDIGO         0x4810      /*  75,   0, 130 */
#define COLOR_DARKRED        0x8000      /* 128,   0,   0 */
#define COLOR_OLIVE          0x7BE0      /* 128, 128,   0 */
#define COLOR_GRAY           0x8410      /* 128, 128, 128 */
#define COLOR_GREY           0x8410      /* 128, 128, 128 */
#define COLOR_SKYBLUE        0x867D      /* 135, 206, 235 */
#define COLOR_BLUEVIOLET     0x895C      /* 138,  43, 226 */
#define COLOR_LIGHTGREEN     0x9772      /* 144, 238, 144 */
#define COLOR_DARKVIOLET     0x901A      /* 148,   0, 211 */
#define COLOR_YELLOWGREEN    0x9E66      /* 154, 205,  50 */
#define COLOR_BROWN          0xA145      /* 165,  42,  42 */
#define COLOR_DARKGRAY       0x7BEF      /* 128, 128, 128 */
#define COLOR_DARKGREY       0x7BEF      /* 128, 128, 128 */
#define COLOR_SIENNA         0xA285      /* 160,  82,  45 */
#define COLOR_LIGHTBLUE      0xAEDC      /* 172, 216, 230 */
#define COLOR_GREENYELLOW    0xAFE5      /* 173, 255,  47 */
#define COLOR_SILVER         0xC618      /* 192, 192, 192 */
#define COLOR_LIGHTGRAY      0xC618      /* 192, 192, 192 */
#define COLOR_LIGHTGREY      0xC618      /* 192, 192, 192 */
#define COLOR_LIGHTCYAN      0xE7FF      /* 224, 255, 255 */
#define COLOR_VIOLET         0xEC1D      /* 238, 130, 238 */
#define COLOR_AZUR           0xF7FF      /* 240, 255, 255 */
#define COLOR_BEIGE          0xF7BB      /* 245, 245, 220 */
#define COLOR_MAGENTA        0xF81F      /* 255,   0, 255 */
#define COLOR_TOMATO         0xFB08      /* 255,  99,  71 */
#define COLOR_GOLD           0xFEA0      /* 255, 215,   0 */
#define COLOR_ORANGE         0xFD20      /* 255, 165,   0 */
#define COLOR_SNOW           0xFFDF      /* 255, 250, 250 */
#define COLOR_YELLOW         0xFFE0      /* 255, 255,   0 */


/* Font defines */
//#define FONT_HEADER_SIZE 4 // 1: pixel width of 1 font character, 2: pixel height,
#define FONT_HEADER_SIZE 5 // 1: pixel width of 1 font character, 2: pixel height,  Max char per line
//#define readFontByte(x) pgm_read_byte(&cfont.font[x])


#define ILI9341_TFTWIDTH  240L
#define ILI9341_TFTHEIGHT 320L
#define Max_Lcd_Buff 320L*240L

extern Byte Terminal6x8[];
extern Byte Terminal12x16[];
extern Byte Trebuchet_MS13x21[];
extern unsigned short Terminal5x11[];
extern Byte Trebuchet_MS16x23[];
extern unsigned short Arial_Narrow22x32[] ;
extern unsigned short NI7SEG22x28[];
extern unsigned short NI7SEG26x35[];


extern unsigned char Arial_Bold[]; // 3044
extern char flag;

extern int _maxX, _maxY, _bgColor;
extern Byte  _orientation ;
//char  hwSPI, checkSPI, blState;

// unsigned char Terminal7x8[]  = {
//        0x07, 0x08, 0x20, 0x60, 25
//        cfont.width=6   cfont.height=8   cfont.offset = 0x20=SPACE   cfont.numchars= 96  25 chars/ligne
//        FONT_HEADER_SIZE 5
 struct _currentFont
 {
    unsigned char * font;
    Byte width;
    Byte height;
    Byte offset;
    Byte numchars;
    unsigned char MaxC;
    Byte nbrows;
  } cfont;

  void Init_ILI9341(void);
  void Clear_LCD(void);
  void TFT_CLS(void);
  void Put_Pixel(int x1,int y1,Word color);
  void Rectangle_Plein(int x1,int y1, int x2,int y2,Word color);
  void SetWindow(int x1, int y1, int x2, int y2);
  void SendCmd(unsigned char c);
  void SendData(Byte c);
  Byte Set_Cursor_XY(int x, int y);
  Word Set_RGB_Color(Byte red, Byte green, Byte blue);
  Word SetColor(Byte red, Byte green, Byte blue);
        
  void SetBacklight(char flag);
  void SetBacklightBrightness(Byte brightness);
  void SetDisplay(char flag);
  void Invert(char flag);
  void SetBackgroundColor(Word color); //= COLOR_BLACK);
  void SetOrientation(Byte orientation);
  void SetAddrWindow(int x0, int y0, int x1, int y1);
  void SetTextColor(Word Color) ;
  Byte GetOrientation(void);
  void SetFont( unsigned char * font);
  int maxX2(void);
  int maxY2(void);
  unsigned char Set_Cursor_XY(int x, int y);
      
  void DrawLine(Word x1,Word y1, Word x2, Word y2, Word color);
  void DrawText(int x, int y, Byte * s, Word Color);
  Byte DrawChar(int x, int y, Byte ch, Word color);
  void DrawCircle(int x0, int y0, int r, Word color);
  void Swaping(int a, int b);
  void OrientCoordinates(int x1, int y1);
  void Invert_Display(char bb);

  void DrawBitmap(int, int y, const Byte *bitmap, int  w, int h, Word color);
  void drawXBitmap(int x, int y, const Byte *bitmap, int w, int h, Word color);

 #include "C:\_MikroC\_MesProjets_MikroC\_LCD_ILI9341_Touch_screen\TFT_ILI9341_SPI_1807.c"