 
  #define Version "180226"
 #define Directory  "C:\\_MikroC\\_MesProjets_MikroC\\_LCD_ILI9341_Touch_screen"
 #define Project   "18F26k22_LCD_Touch_ILI9341_SPI.mcppi"
 #define Source     "_18F26K22_SPI_LCD_ILI9341_XPT2046_"

 #define FOSC_INTERNE
 #define FOSC "8MHzxPLL"      // 8MHz  x4 PLL
 //P18F26K22_FOSC_interne_8xPLL_32Mhz.cfgsch
 #define MCU  "18F26K22"
 #define POWER_Supply "3.3 to 3.6V MAXI"
 
// ILI9225 screen size
//#define ILI9341_LCD_WIDTH  320
//#define ILI9225_LCD_HEIGHT 240
 
 #define uint8_t  unsigned char
 #define int16_t int
 #define longuint32_t unisgned long
 #define bitRead(value, bit) (((value) >> (bit)) & 0x01)
 #define Word unsigned int

 //ac:Pinout18F26K22
 
  //ac:SPI_Connections
 
 
 // Hardware
 /*

 Pin 28 RB7  -----------------ICSP Data
 Pin 27 RB6  -----------------ICSP Clock
 Pin 26 RB5
 Pin 25 RB4
 Pin 24 RB3
 Pin 23 RB2
 Pin 22 RB1
 Pin 21 RB0
 Pin 20      VDD --------+5V
 Pin 19      Vss ---------Gnd
 Pin 18  RC7  RX UART  <-- Keyboard
 Pin 17  RC6  TX UART  --> Display    * mettre une pull up de 10K si RX non utilise
 Pin 16  RC5
 Pin 15  RC4  SDA
 
 Pin 14 RC3 SCL
 Pin 13 RC2
 Pin 12 RC1
 Pin 11 RC0
 Pin 10 RA6  --> output fOSC/4
 Pin  9 RA7
 Pin  8 VSS ---------  Gnd
 Pin  7 RA5
 Pin  6 RA4  Output -- Led -- 2,7K --+Vcc
 Pin  5 RA3  ------OWS---DS18B20
 Pin  4 RA2 (DAC)
 Pin  3 RA1  Analog input EA1
 Pin  2 RA0  Analog Input EA0
 Pin  1 RE3 MCLR  Reset --------ICSP PGRM
 
*/
 
// config Bits
//P18F26K22_FOSC_interne_16Mhz.cfgsch
/*
CONFIG1H : $300001 : 0x0029
CONFIG2L : $300002 : 0x001F
CONFIG2H : $300003 : 0x003C
CONFIG3H : $300005 : 0x00BF
CONFIG4L : $300006 : 0x0081
CONFIG5L : $300008 : 0x000F
CONFIG5H : $300009 : 0x00C0
CONFIG6L : $30000A : 0x000F
CONFIG6H : $30000B : 0x00E0
CONFIG7L : $30000C : 0x000F
CONFIG7H : $30000D : 0x0040

*/

#define Byte unsigned char
#define Word unsigned int

#define CLS 12
#define CR 13
#define LF 10
#define TAB 9
#define BACK 8

//sbit Led_Rouge at LATA4_bit  ;
#define Led_On_RA4 LATA4_bit      //tirage au +VCC via 2,7K
#define Led_On_RA4_Direction TRISA4_bit
#define ON 0
#define OFF 1

#define MISO  LATC4_bit  // not used
#define _RST LATC0_bit   // Reset TFT
#define _RS  LATC1_bit   //Command (RS=0)  Parameter (RS=1)
#define _CS  LATC2_bit    // CS
#define _SDI LATC5_Bit   // MOSI  SDO  RC5 MSSP1 SPI data output.
#define _CLK LATC3_Bit   // SCK
#define _LED 0 // 0 if wired to +5V directly
#define  SQ50_trigger   LATA3_bit;

// debug tools :
//#define  SQ50_trigger LATA4_bit
#define FARENHEIGHT
#define DS18B20

#define TFT_BRIGHTNESS 200 // Initial brightness of TFT backlight (optional)
 
 /*
static const unsigned char init_commands[] = {
        4, 0xEF, 0x03, 0x80, 0x02,
        4, 0xCF, 0x00, 0XC1, 0X30,
        5, 0xED, 0x64, 0x03, 0X12, 0X81,
        4, 0xE8, 0x85, 0x00, 0x78,
        6, 0xCB, 0x39, 0x2C, 0x00, 0x34, 0x02,
        2, 0xF7, 0x20,
        3, 0xEA, 0x00, 0x00,
        2, ILI9341_PWCTR1, 0x23, // Power control
        2, ILI9341_PWCTR2, 0x10, // Power control
        3, ILI9341_VMCTR1, 0x3e, 0x28, // VCM control
        2, ILI9341_VMCTR2, 0x86, // VCM control2
        2, ILI9341_MADCTL, 0x48, // Memory Access Control
        2, ILI9341_PIXFMT, 0x55,
        3, ILI9341_FRMCTR1, 0x00, 0x18,
        4, ILI9341_DFUNCTR, 0x08, 0x82, 0x27, // Display Function Control
        2, 0xF2, 0x00, // Gamma Function Disable
        2, ILI9341_GAMMASET, 0x01, // Gamma curve selected
        16, ILI9341_GMCTRP1, 0x0F, 0x31, 0x2B, 0x0C, 0x0E, 0x08,
                0x4E, 0xF1, 0x37, 0x07, 0x10, 0x03, 0x0E, 0x09, 0x00, // Set Gamma
        16, ILI9341_GMCTRN1, 0x00, 0x0E, 0x14, 0x03, 0x11, 0x07,
                0x31, 0xC1, 0x48, 0x08, 0x0F, 0x0C, 0x31, 0x36, 0x0F, // Set Gamma
        3, 0xb1, 0x00, 0x10, // FrameRate Control 119Hz
        0
};

   */
#define MAXLEN0 40
#define MAXLEN1 80

const char Mode_Orientation[][17]={"Portrait        ",
                                 "Paysage         ",
                                 "Portrait Inverse",
                                 "Paysage Inverse "};



unsigned char Buffer[256];
char Debug_Font=0;
unsigned char TEXTE[MAXLEN1];
unsigned char buffer1[MAXLEN1];
unsigned char Buffer_Font[MAXLEN0];
unsigned char * txt;
int i,j,k,l;
char *p1;

unsigned char CRam1[40];
unsigned int Index;
char flag;
unsigned char Dummy;

unsigned int EA0;
unsigned int clk;
  
volatile char  c1,c2;
volatile int DataReady1;
volatile int CptFO1,CptFE1;
volatile int Index1,i1;
int erreurs;
unsigned int Color,bgColor,textColor,textBgcolor;
int _width,_height,_maxX,_maxY;
Byte Negatif=1;

unsigned long L1;
static unsigned char * pp;
static unsigned int km;
static int Font_Active;

float NowTemp,OldTemp;
char Flag_Mesure=1;

void Print_Cte_String (const char * q);
void fltToa (double x, unsigned char *str,char precision);
void Draw_CText(Word x,Word y,const unsigned  char *T,unsigned Word Co) ;
void  Param_Font(void);
void Draw_CText(Word x,Word y,const unsigned  char *T,unsigned Word Co);



void Interrupts_High() iv 0x0008 ics ICS_AUTO 
{   
  if((RC1IE_bit==1)&& (PIR1.RC1IF==1)) // si une interruption UART1 arrive
  {
   c1 =RC1REG; // le lire => RAZ  RCIF
   if(RCSTA1.FERR==1 )
    {
     RCSTA1.SPEN = 0 ;
     CptFE1++;
     RCSTA1.SPEN= 1 ;
     c1=0;
    }
    if (RCSTA1.OERR==1)    // voir parag 16.1.26 p273
    {
       RCSTA1.CREN = 0 ;
       CptFO1++;
       RCSTA1.CREN = 1 ;
       c1=0;
    }
    if(c1 != CR )
    {
      buffer1[i1] = c1;
      Index1=i1;
      i1++;
      if (i1>(MAXLEN1-1))
      {
        DataReady1=2;
        RC1IE_bit=0;
        buffer1[i1-1]=0;
        Index1=i1;
        i1=0;
      }
      else     
      DataReady1 = 0;
       }
       else
        {
         buffer1[i1] = 0;         //  0 a la fin du string
        DataReady1 = 1;      // drapeau Data recue
        Index1=i1;
        i1=0;
     }
    
   PIR1.RC1IF=0;  
   } //if PIR1
 }
 
 #include "TFT_ILI9341_SPI_2018.h"

void strConstRamCpy(char *dest, const char *source) {
  while(*source) *dest++ = *source++ ;
  *dest = 0 ;    // terminateur
}

void UART1_Write_CText(const char *txt)
 {
   while (*txt)
     UART1_Write(*txt++);
 }

void Print_Cte_String (const char * q)
{
while(*q)
{
UART1_Write(*q++);
}
} 

void CRLF1()
{
  UART1_Write(CR);
  UART1_Write(LF);
  }
  
void fltToa (double x, unsigned char *str,char precision)
{
 /* converts a floating point number to an ascii string */
 /* x is stored into str, which should be at least 30 chars long */
 int ie, i, k, ndig;
 double y;
 ndig = ( precision<=0) ? 7 : (precision > 22 ? 23 : precision+1);
 ie = 0;
 /* if x negative, write minus and reverse */
 if ( x < 0)
 {
  *str++ = '-';
  x = -x;
 }
 /* put x in range 1 <= x < 10 */
 if (x > 0.0) while (x < 1.0)
 {
  x *= 10.0;                // a la place de =*
  ie--;
 }
 while (x >= 10.0)
 {
   x = x/10.0;
   ie++;
 }
 ndig += ie;                                // a la place de =+
 //round. x is between 1 and 10 and ndig will be printed to
 // right of decimal point so rounding is ...
 for (y = i = 1; i < ndig; i++)  y = y/10.;
 x += y/2.0;
 if (x >= 10.0) {x = 1.0; ie++;}
 if (ie<0)
 {
   *str++ = '0'; *str++ = '.';
   if (ndig < 0) ie = ie-ndig;
   for (i = -1; i > ie; i--)  *str++ = '0';
 }
 for (i=0; i < ndig; i++)
 {
   k = x;
   *str++ = k + '0';
   if (i ==  ie ) *str++ = '.';
   x -= (y=k);
   x *= 10.0;
 }
*str = '\0';
}


void main() 
{
#ifdef FOSC_INTERNE
OSCTUNE=0;
//OSCCON = 0b01110010  ; //0x72 ;     //Oscillateur  16Mhz
//OSCCON = 0b01100010  ; //0x62 ;     //Oscillateur  8Mhz   (SANS PLL)
OSCCON =   0b01100000  ; //0x60 ;     //Oscillateur  8Mhz *4 (AVEC PLL)
OSCTUNE.PLLEN=1;
while (OSCCON.HFIOFS==0); // wait stable oscillator
#else
// Q=20Mhz
#endif

ANSELA=3;
ANSELB=0 ;
ANSELC=0 ;
TRISB=0xFF;
TRISC=0b10010000;      // RC5 MSSP1 SPI data output.
TRISA=0b00001111;
INTCON2.RBPU=0;      // enable Pull-up
Led_On_RA4_Direction=0;
Led_On_RA4=ON;   // led avec tirage au +VCC via 2,7K

TEXTE[0]=0;
buffer1[0]=0;
Buffer_Font[0]=0;
CRam1[0]=0;

i1=0;
Index1=0;
DataReady1=0;
CptFO1=CptFE1=0;
txt=TEXTE;
for (i=0;i<5;i++) 
{
  Led_On_RA4=!Led_On_RA4;
  Delay_ms(1000);
  }


ADC_Init();
EA0 = ADC_Read(1);   // Get 10-bit results of AD conversion

UART1_Init(19200);  // Initalize USART (38400,8,N,1)
UART_Set_Active(&UART1_Read, &UART1_Write, &UART1_Data_Ready, &UART1_Tx_Idle);
Delay_ms(200);
UART1_Write(CLS);   // Erase screen terminal  :it is an option on Vbray Terminal!
CRLF1();
Print_Cte_String(" MCU : " MCU"\r\n");
Print_Cte_String(" Power supply: "POWER_Supply"\r\n");
Print_Cte_String(" Directory : " Directory"\r\n");
Print_Cte_String(" Projet : " Project"\r\n");
Print_Cte_String(" Source : "Source"_"Version".c\r\n");
Print_Cte_String(" FOSC  : " FOSC"\r\n");
Print_Cte_String(" Version minimaliste de test \r\n");
 CRLF1()    ;

 Delay_ms(200);
 i1=0;
 Index1=0;
 DataReady1=0;
 CptFO1=CptFE1==0;
 RCON.IPEN=1   ; // enable priority levels
 INTCON.PEIE = 1 ;
 RC1IE_bit=0;
 GIE_bit=0;
 erreurs=0;
 i=0;
 Debug_Font=0;

 Print_Cte_String("Init  SPI1 \r\n");
 SPI1_Init();
 Print_Cte_String("Init TFT LCD 2,2\" 240x320 \r\n");
 Delay_1sec();

  _CS=1;
  _RST=1;
  Delay_ms(250);
  _RST=0;
  Delay_ms(20);
  _RST=1;
  Delay_ms(200);
  
   _CS=0;
   //SQ50_trigger=1;
   Delay_ms(100);
   SendCmd(0x3A); SendData(0x55);    // set pixel format -> 65k rgb565
   SendCmd(0x20);                    // inverse video off
   SendCmd(0x11); Delay_ms(10);       // exit sleep
   SendCmd(0x29); Delay_ms(10);     // display on
   SendCmd(0x36); SendData(0x48);    // set memory access control
   _CS = 1;

  SetWindow(0,0,239,319);
  //Color=SetColor(255,255,0);
  SetOrientation(0);

  UART1_Write_CText(" Lets Go !\r\n");
  CRLF1();
 
  k=0;
  while (1)
  {
  SetOrientation(k);
  Clear_LCD();
  Delay_1sec();
  UART1_Write_CText(" Mode  ");
  UART1_Write_CText(Mode_Orientation[k]);
  CRLF1();
  UART1_Write_CText(" Rectangle_Plein(0,0,239,319,COLOR_MAGENTA\r\n");
  Rectangle_Plein(0,0,239,319,COLOR_MAGENTA);
   Delay_1sec();
  UART1_Write_CText(" Rectangle_Plein(4,4,235,315,COLOR_WHITE\r\n");
  Rectangle_Plein(4,4,235,315,COLOR_WHITE);
   Delay_1sec();
  UART1_Write_CText(" Rectangle_Plein(200,280,239,319,COLOR_RED\r\n");
  Rectangle_Plein(200,280,239,319,COLOR_RED);
   Delay_1sec();
   UART1_Write_CText(" Fill_Circle(180,70,30,COLOR_YELLOW \r\n");
  FillCircle(180,70,30,COLOR_YELLOW);
  Delay_1sec();
  UART1_Write_CText(" Rectangle_Plein(1,1,40,40,COLOR_GREEN \r\n");
  Rectangle_Plein(1,1,40,40,COLOR_GREEN);
   Delay_1sec();
  UART1_Write_CText(" Rectangle_Plein(10,270,70,310,COLOR_CYAN \r\n");
  Rectangle_Plein(10,270,70,310,COLOR_CYAN);
  Delay_1sec();
  UART1_Write_CText(" Fill_Circle(170,180,40,COLOR_BROWN \r\n");
  FillCircle(120,160,40,COLOR_BROWN);
  Delay_1sec();
  Delay_1sec();
    Led_On_RA4 = !Led_On_RA4;      // led clignote chaque seconde
   CRLF1();
   k++;
  if(k>3) k=0;
  //Invert_Display(Negatif)  ;
  // Negatif=!Negatif;
  }

 }
 /*
  MCU : 18F26K22
 Power supply: 3.3 to 3.6V MAXI
 Directory : C:\_MikroC\_MesProjets_MikroC\_LCD_ILI9341_Touch_screen
 Projet : 18F26k22_LCD_Touch_ILI9341_SPI.mcppi
 Source : _18F26K22_SPI_LCD_ILI9341_XPT2046__180226.c
 FOSC  : 8MHzxPLL
 Version minimaliste de test

Init  SPI1
Init TFT LCD 2,2" 240x320
 Lets Go !

 Mode  Portrait
 Mode  Paysage
 Mode  Portrait Inverse
 Mode  Paysage Inverse
 Mode  Portrait
 Mode  Paysage
 

0 1 mikroCPIC1618.exe -MSF -DBG -pP18F26K22 -RA -C -Y -O11111114 -fo32 -EH"C:\_MikroC\_MesProjets_MikroC\_LCD_ILI9341_Touch_screen\18F26k22_LCD4x20_DS1307_EEPROM.ihex" -N"C:\_MikroC\_MesProjets_MikroC\_LCD_ILI9341_Touch_screen\18F26k22_LCD_Touch_ILI9341_SPI_minimal.mcppi" -SP"C:\_MikroC\mikroC PRO for PIC\Defs\" -SP"C:\_MikroC\mikroC PRO for PIC\uses\P18\" -SP"C:\_MikroC\_MesProjets_MikroC\_LCD_ILI9341_Touch_screen\" -SP"C:\_MikroC\_MesProjets_MikroC\" -IP"C:\_MikroC\mikroC PRO for PIC\uses\P18\" -IP"C:\_MikroC\_MesProjets_MikroC\_LCD_ILI9341_Touch_screen\" -IP"C:\_MikroC\_MesProjets_MikroC\" -IP"C:\_MikroC\mikroC PRO for PIC\" "_18F26K22_SPI_LCD_ILI9341_test_minimaliste_180306.c" "__Lib_Math.mcl" "__Lib_MathDouble.mcl" "__Lib_System.mcl" "__Lib_Delays.mcl" "__Lib_CType.mcl" "__Lib_CString.mcl" "__Lib_CStdlib.mcl" "__Lib_MemManager.mcl" "__Lib_Conversions.mcl" "__Lib_Sprintf.mcl" "__Lib_OneWire.mcl" "__Lib_ADC_K22_B.mcl" "__Lib_EEPROM_1024.mcl" "__Lib_FLASH_w64_e64.mcl" "__Lib_SPI_c345b123.mcl" "__Lib_UART_c67b67.mcl"
0 1139 Available RAM: 3875 [bytes], Available ROM: 65536 [bytes]
0 122 Compilation Started P18F26K22.c
2623 123 Compiled Successfully P18F26K22.c
0 122 Compilation Started __Lib_Delays.c
172 123 Compiled Successfully __Lib_Delays.c
0 122 Compilation Started __Lib_MemManager.c
34 1508 Implicit conversion of int to ptr __Lib_MemManager.c
231 123 Compiled Successfully __Lib_MemManager.c
0 122 Compilation Started _18F26K22_SPI_LCD_ILI9341_test_minimaliste_180306.c
0 1004 interrupt handler (Interrupts_High at 0x0008) _18F26K22_SPI_LCD_ILI9341_test_minimaliste_180306.c
513 1163 Variable 'inTrans' has been declared, but not used tft_ili9341_spi_1803.c
435 123 Compiled Successfully _18F26K22_SPI_LCD_ILI9341_test_minimaliste_180306.c
0 127 All files Compiled in 109 ms
0 1144 Used RAM (bytes): 327 (8%)  Free RAM (bytes): 3548 (92%) Used RAM (bytes): 327 (8%)  Free RAM (bytes): 3548 (92%)
0 1144 Used ROM (bytes): 3594 (5%)  Free ROM (bytes): 61942 (95%) Used ROM (bytes): 3594 (5%)  Free ROM (bytes): 61942 (95%)
0 125 Project Linked Successfully 18F26k22_LCD_Touch_ILI9341_SPI_minimal.mcppi
0 128 Linked in 31 ms
0 129 Project '18F26k22_LCD_Touch_ILI9341_SPI_minimal.mcppi' completed: 390 ms
0 103 Finished successfully: 07 mars 2018, 12:18:07 18F26k22_LCD_Touch_ILI9341_SPI_minimal.mcppi
*/